// Learning Processing
// Daniel Shiffman
// http://www.learningprocessing.com
// Example 15-8: Adjusting image brightness

// Maarten Wijntjes adjsusted the code to make it a hue roator
PImage img;

void setup() {
   
  //Put the name of the file here:
  img = loadImage("dylan.jpg");
  size(img.width, img.height);

}

void draw() {
  colorMode(HSB);
  loadPixels();

  
  for (int x = 0; x < img.width; x++ ) {
    for (int y = 0; y < img.height; y++ ) {

      // Calculate the 1D pixel location
      int loc = x + y*img.width;

      
      float h = hue (img.pixels[loc]);
      float s = saturation (img.pixels[loc]);
      float b = brightness (img.pixels[loc]);

          
      float adjustHue =round(255*mouseX/(img.width));
      h = h+adjustHue;

      // Need to take modulo (which is the % sign) to make the hue periodic    
      h = h % 255; 
  
      color c = color(h,s,b);
      pixels[loc] = c;
    }
  }
  
  updatePixels();  
}
